// This program doesn't check time limit!

// Put here link to your unit
#include "file.cpp"

// Comment this define if you want to be second player
#define i_am_first_player


// Do not change the following code -----------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define max(a,b) (((a)>(b))?(a):(b))


void show_error(char *mes)
{
   printf("Error: %s\n", mes);
   exit(1);
}


int test_field(tfield &f)
{
  int i, j;
  int m[10][10], c[6];
  for (i = 0; i < 9; i++)
     for (j = 0; j < 9; j++)
     {
        if (f[i][j] == '#' && f[i+1][j+1] == '#') return 0;
        if (f[i][j+1] == '#' && f[i+1][j] == '#') return 0;
     }
  m[0][0] = (f[0][0] == '#') ? 1 : 0;
  for (i = 1; i < 10; i++)
  {
     if (f[0][i] == '.') m[0][i] = 0;
     else m[0][i] = 1 + m[0][i - 1];
     if (f[i][0] == '.') m[i][0] = 0;
     else m[i][0] = 1 + m[i - 1][0];
  }
  for (i = 1; i < 10; i++)
     for (j = 1; j < 10; j++)
        if (f[i][j] == '.') m[i][j] = 0;
        else m[i][j] = 1 + max(m[i - 1][j], m[i][j - 1]);
  c[5] = 0;
  for (i = 4; i > 0; i--) c[i] = (5 - i) + c[i + 1];
  for (i = 0; i < 10; i++)
     for (j = 0; j < 10; j++)
        if (m[i][j] > 4) return 0;
        else if (m[i][j] > 0) c[m[i][j]]--;
  for (i = 1; i <= 4; i++) 
     if (c[i]) return 0;
  return 1;
}


void print_field(FILE *flog, tfield &field)
{
   int i, j;
   for (i = 0; i < 10; i++)
   {
      for (j = 0; j < 10; j++) fprintf(flog, "%c", field[i][j]);
      fprintf(flog, "\n");
   }
   fprintf(flog, "\n");
}

int main()
{
   int i, j, turn, player_ships, computer_ships, player_number;
   tfield player_field, computer_field;
   int player_shot[10][10], computer_shot[10][10];
   FILE *flog;
   
   player_number = 2;
#ifdef i_am_first_player
   player_number = 1;
#endif   
   flog = fopen("gamelog.txt", "w");
  
   init(player_field);
   for (i = 0; i < 10; i++)
      for (j = 0; j < 10; j++)
         if (player_field[i][j] != '.' && player_field[i][j] != '#')
            show_error("Your field contains incorrect symbols.\nIt should only contain symbols '.' and '#'");
   if (!test_field(player_field))
      show_error("Your ships arrangement is not correct");
  
   strcpy(computer_field[0], "........#.");
   strcpy(computer_field[1], "#.####..#.");
   strcpy(computer_field[2], "#.......#.");
   strcpy(computer_field[3], "#....##...");
   strcpy(computer_field[4], "..#.......");
   strcpy(computer_field[5], "..#.......");
   strcpy(computer_field[6], "......#...");
   strcpy(computer_field[7], ".#..#....#");
   strcpy(computer_field[8], ".#........");
   strcpy(computer_field[9], ".......#.");
   computer_field[9][9] = '.';  

#ifdef i_am_first_player
   print_field(flog, player_field);
   print_field(flog, computer_field);
#else
   print_field(flog, computer_field);
   print_field(flog, player_field);
#endif

   memset(player_shot, 0, sizeof(player_shot));
   memset(computer_shot, 0, sizeof(computer_shot));
   player_ships = computer_ships = 10;
#ifdef i_am_first_player
   turn = 1;
#else
   turn = 2;
#endif

   int n = 0;
   char result = ' ';
   tmove moves[101];

   while (player_ships && computer_ships)
      if (turn == 1)
      {
      	 int r, c, u, v, killed;
         makemove(result, n, moves, r, c);
         if (r < 0 || r > 9 || c < 0 || c > 9)
            show_error("makemove returned wrong position (r, c)");
         if (player_shot[r][c])
            show_error("Second shot in the same position");
         player_shot[r][c] = 1;
         if (computer_field[r][c] == '.')
         {
            result = 'p';
            turn = 2;
         }
         else
         {
            killed = 1;
            u = r - 1, v = c;
            while (u >= 0 && computer_field[u][v] == '#')
            {
               if (!player_shot[u][v]) killed = 0;
               u--;
            } 
            u = r + 1, v = c;
            while (u < 10 && computer_field[u][v] == '#')
            {
               if (!player_shot[u][v]) killed = 0;
               u++;
            } 
            u = r, v = c - 1;
            while (v >= 0 && computer_field[u][v] == '#')
            {
               if (!player_shot[u][v]) killed = 0;
               v--;
            } 
            u = r, v = c + 1;
            while (v < 10 && computer_field[u][v] == '#')
            {
               if (!player_shot[u][v]) killed = 0;
               v++;
            } 
            if (!killed) result = 'w';
            else
            {
               result = 'k';
               computer_ships--;
            }
         }
         n = 0;
         char res_string[10];
         if (computer_field[r][c] == '.') 
            strcpy(res_string, "past");
         else if (killed)
            strcpy(res_string, "killed");
         else
            strcpy(res_string, "wounded");
         fprintf(flog, "%d %c%d %s\n", player_number, (char)r + 'a', c, res_string); 
      }
      else
      {
         int count, r, c, killed, u, v;  
         count = 0;
         for (i = 0; i < 10; i++)
            for (j = 0; j < 10; j++)
               if (!computer_shot[i][j]) ++count;
         count = abs(rand() % count);
         for (i = 0; i < 10; i++)
            for (j = 0; j < 10; j++)
               if (!computer_shot[i][j])
                  if (count-- == 0)
                  {
                     r = i;
                     c = j;
                  }
         computer_shot[r][c] = 1;
         if (player_field[r][c] == '.')
         {
            moves[n].result = 'p';
            turn = 1;
         }
         else
         {
            killed = 1;
            u = r - 1, v = c;
            while (u >= 0 && player_field[u][v] == '#')
            {
               if (!computer_shot[u][v]) killed = 0;
               u--;
            } 
            u = r + 1, v = c;
            while (u < 10 && player_field[u][v] == '#')
            {
               if (!computer_shot[u][v]) killed = 0;
               u++;
            } 
            u = r, v = c - 1;
            while (v >= 0 && player_field[u][v] == '#')
            {
               if (!computer_shot[u][v]) killed = 0;
               v--;
            } 
            u = r, v = c + 1;
            while (v < 10 && player_field[u][v] == '#')
            {
               if (!computer_shot[u][v]) killed = 0;
               v++;
            }
            if (!killed) moves[n].result = 'w';
            else
            {
               moves[n].result = 'k'; 
               player_ships--;
            }
         }       
         moves[n].r = r;
         moves[n++].c = c;
         char res_string[10];
         switch (moves[n - 1].result)
         {
            case 'p': strcpy(res_string, "past"); break;
            case 'w': strcpy(res_string, "wounded"); break;
            case 'k': strcpy(res_string, "killed"); break;
         }
         fprintf(flog, "%d %c%d %s\n", 3 - player_number, (char)r + 'a', c, res_string);
      } 

   printf("No errors in your program was found\n");
   if (computer_ships == 0)
      printf("The winner is your program\n");
   else
      printf("The winner is my program\n");
  
   return 0;
}